/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumlistpricewidgetdesignerplugin.h"

#include "mediumlistpricewidget.h"

MediumListPriceWidgetDesignerPlugin::MediumListPriceWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumListPriceWidgetDesignerPlugin::name() const
{
	return "MediumListPriceWidget";
}

QString MediumListPriceWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumListPriceWidgetDesignerPlugin::toolTip() const
{
	return "Use it to show and edit list price of a medium";
}

QString MediumListPriceWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumListPriceWidgetDesignerPlugin::includeFile() const
{
	return "mediumlistpricewidget.h";
}

QIcon MediumListPriceWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumListPriceWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumListPriceWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumListPriceWidget(parent);
}

QString MediumListPriceWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumListPriceWidget\" name=\"listPriceWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumListPriceWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumListPriceWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mediumlistpricewidgetdesignerplugin.moc"
