/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef CONNECTMEDIASEARCH_H
#define CONNECTMEDIASEARCH_H

#include "libmacro.h"

#include "settingswidget.h"
#include "ui_connectmediasearch.h"
#include "medium.h"

class SearchPlugin;

/**
	* @brief Let the user connect the Attributes of specific media and
	*   the available attributes of the specific SearchPlugin
	*
	* @todo Auto connect same named attributes (see #151)
	*/
class EXPORT_DLL ConnectMediaSearch : public SettingsWidget, private Ui::ConnectMediaSearch
{
  Q_OBJECT
  public:
    ConnectMediaSearch(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		~ConnectMediaSearch();
    void setPlugins(Medium *medium, SearchPlugin *searchPlugin);
    bool checkSettings();
		
  public slots:
    bool saveSettings();
    
  private slots:
    void assign();
    void remove();
    void indexChanged(QModelIndex index);
    
  private:
		void loadSettings();
		
    QModelIndex mediaIndex, searchIndex, connectionIndex;
    QString mediaGroup, mediaName, searchGroup;
		int numMediaAttrs, numSearchAttrs;
		QStringList mediaAttrs, searchAttrs;
		Medium *medium;
		SearchPlugin *searchPlugin;
		bool canceled, saved, deleteMedium;
		int numMediaModelAttrs, numSearchPluginAttrs;
		QMap<QString, QString> searchMap;
		QList<ColKeyTrans> mediaMap;
};

#endif // CONNECTMEDIASEARCH_H
