/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DBBACKUP_H
#define DBBACKUP_H

#include <setupwizardwidget.h>

#include "ui_dbbackup.h"

#include <QFileInfo>
#include <QTextStream>

class DBBackup : public SetupWizardWidget, private Ui::DBBackup
{
	Q_OBJECT
	public:
		DBBackup(SetupWizardObject *newObject, QWidget *parent = 0, Qt::WindowFlags flags = 0);
		static QString mysqlEscape(QString input);
		
	public slots:
		bool finish();
    bool saveSettings();
		void abort();
		
	private slots:
		void setDumpFile();
		
	private:
		/**
			* dump the sql create statement and the content of the @p table to  @p stream
			* @return true if all is done correctly and false if an error occurs
			*/
		bool dumpTable ( QString table, QTextStream &stream);
		/**
			* we must insert them in correct order, because some need other views
			*/
		bool dumpView ( QString view, QTextStream &stream);
		QStringList sortViews(QStringList views);
		void setRange ( int num );
    void finishedStep();
    void actualStep ( QString msg );
    void log ( QString msg );
		
		QFileInfo dumpFile;
		QString codecName;
		bool doAbort;
		
	signals:
		void exportStarted();
		void exportFinished(bool result);
};

#endif // DBBACKUP_H
