/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DBSETTINGS_H
#define DBSETTINGS_H

#include "libmacro.h"

#include "setupwizardwidget.h"
#include "ui_dbsettings.h"

/**
	* This class is used to let the user enter some settings related to the database.
	* The widget is displayed at to places. First it is used at the @see SetupWizard and second
	* at the @see SettingsDialog.
	* The Part of creating database and user is only displayed, if the SetupWizardObject
	* at the constructor is not null.
	*/
class EXPORT_DLL DBSettings : public SetupWizardWidget, private Ui::DBSettings
{
    Q_OBJECT
  public:
		/**
			* if @p newObject is null, the createDatabaseBox is hidden, because the widget runs in
			* @see SettingsDialog mode.
			*/
    DBSettings ( SetupWizardObject *newObject = 0, QWidget *parent = 0, Qt::WindowFlags fl = 0 );

  public slots:
		/**
			* if create database and/or create user is choosen,
			* this function executes needed commands.
			* it assumes, that the user has the privileges to use the database,
			* if he only select create database
			*/
    bool finish();
    bool saveSettings();

  private slots:
    void typeChanged ( QString text );
};

#endif // DBSETTINGS_H
