/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DELEGATEFOREIGNKEY_H
#define DELEGATEFOREIGNKEY_H

#include "libmacro.h"

#include <QStyledItemDelegate>

#include <QPainter>

class QSqlQueryModel;
class QTimer;

/**
  * displays the data of a foreignkey
	* if there are more than maxComboItems, it switches to QLineEdit with autocompletion
	* if there are more than maxCompleteItems, it loads the completer after 3 inserted characters to reduce load
	* @todo last one is not useable right now
  */

class EXPORT_DLL DelegateForeignKey : public QStyledItemDelegate{
  Q_OBJECT
  public:
    /**
      * @param table the table where the foreignkey points to
      * @param matchColumn the column which is the same in showed table and foreignkey table (at table @p table)
      * @param resultColumn the column at the foreignkey table which holds the content to be displayed
      */
    DelegateForeignKey(QString table, QString matchColumn, QString resultColumn, QWidget *parent = 0);
		void reloadForeignKeys();

		/**
			* @todo must be really improved to use QCompleter with only part of the table (useExtendedCompleter)
			*/
    void paint(QPainter *painter, const QStyleOptionViewItem &option,
            const QModelIndex &index) const;
    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                       const QModelIndex &index) const;
    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
                   const QModelIndex &index) const;

  protected:

  private slots:
    void commitAndCloseEditor();
		void doCloseEditor();
		/**
			* @todo must be really improved
			*/
		void updateCompleter();
// 		void doAddPair(QString key, unsigned int value);

  private:
		/**
			* the QString, int order is needed,
			* because the entries should be ordered after the string's
			*/
    QMap<QString, unsigned int> mapOutIn;
    QString resTable, matchCol, resCol;
		QSqlQueryModel *resultModel;
		int maxComboItems, maxCompleteItems;
		bool useComboBox, useCompleter, useExtendedCompleter;
		QTimer *timer;
		
	signals:
// 		void addPair(QString key, unsigned int value);
};

#endif // DELEGATEFOREIGNKEY_H
