/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MACTION_H
#define MACTION_H

#include "libmacro.h"
#include <QAction>

/**
	* Check's wether the option icon and text is set to true or not
	* and if false, the text is removed
	* to get an action with same text (independent from iconAndText) call actionWithText()
	*/
class EXPORT_DLL MAction : public QAction
{
	Q_OBJECT
	public:
		MAction ( QObject *object = 0 );
		MAction ( const QString & text, QObject * parent = 0 );
		MAction ( const QIcon & icon, const QString & text, QObject * parent = 0 );
		~MAction();
		/**
			* If the returned action is triggered, this action emit the triggered signal too!
			* the returned action is alse enabled or disabled when this action is enabled or disabled
			*/
		QAction *actionWithText();
		void   setText ( const QString & text );
	
	public slots:
		void setEnabled ( bool status );
		void setDisabled ( bool status );
		
	private slots:
		void triggeredByPass();
		
	private:
		void init();
		
		QString myText;
		bool iconsAndText;
		QAction *myActionWithText;
};

#endif // MACTION_H
