/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumdescriptionwidget.h"

#include "medium.h"

#include <QPlainTextEdit>
#include <QVBoxLayout>

MediumDescriptionWidget::MediumDescriptionWidget(Medium* medium, QWidget* parent, Qt::WindowFlags flags)
	: MWidget(parent, flags)
{
	setupUi();
	setMedium(medium);
}

MediumDescriptionWidget::MediumDescriptionWidget(QWidget* parent, Qt::WindowFlags flags)
	: MWidget(parent, flags)
{
	setupUi();
	setMedium(0);
}

void MediumDescriptionWidget::setMedium(Medium* medium)
{
	if(this->medium)
		medium->disconnect(this);
	this->medium = medium;
	
// 	if(medium)
// 		connect(medium, SIGNAL(changed()), this, SLOT(setDescriptionFromMedium()));
	
	bool enable = true;
	if(!medium)
		enable = false;
	setEnabled(enable);
	setDescriptionFromMedium();
}

bool MediumDescriptionWidget::store()
{
	if(!medium)
		return false;
	
	medium->setDescription(textEdit->toPlainText());
	return true;
}

void MediumDescriptionWidget::setDescriptionFromMedium()
{
	if(medium)
		textEdit->setPlainText(medium->description());
}

void MediumDescriptionWidget::setupUi()
{
	this->medium = 0;
	
	QVBoxLayout *ml = new QVBoxLayout(this);
	setLayout(ml);
	ml->setMargin(0);
	
	textEdit = new QPlainTextEdit(this);
	ml->addWidget(textEdit);
}

#include "mediumdescriptionwidget.moc"
