/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMDESCRIPTIONWIDGET_H
#define MEDIUMDESCRIPTIONWIDGET_H

#include "libmacro.h"

#include "mwidget.h"

class Medium;

class QPlainTextEdit;

class EXPORT_DLL MediumDescriptionWidget : public MWidget
{
	Q_OBJECT
	public:
		MediumDescriptionWidget(Medium *medium, QWidget *parent = 0, Qt::WindowFlags flags = 0);
		MediumDescriptionWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium *medium);
		bool store();
		
	private slots:
		void setDescriptionFromMedium();
	
	private:
		void setupUi();
		
		Medium *medium;
		QPlainTextEdit *textEdit;
};

#endif // MEDIUMDESCRIPTIONWIDGET_H
