/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMEDITWIDGET_H
#define MEDIUMEDITWIDGET_H

#include <mwidget.h>

class Medium;

class MediumEditWidget : public MWidget
{
	Q_OBJECT
	public:
		MediumEditWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		/**
			* this function is used to set @p newMedium as medium
			* and load all needed stuff
			*/
		virtual void setMedium(Medium *newMedium) = 0;
		/**
			* this function is called, if the changes should be applied to the medium
			*/
		virtual bool store(bool useExistingTransaction = false) = 0;
		
	protected:
		Medium *medium;
};

#endif // MEDIUMEDITWIDGET_H
