/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumevaluationwidget.h"

#include "medium.h"

#include <QHBoxLayout>
#include <QLabel>
#include <QComboBox>

MediumEvaluationWidget::MediumEvaluationWidget(Medium* medium, QWidget* parent, Qt::WindowFlags flags)
	: MWidget(parent, flags)
{
	setupUi();
	setMedium(medium);
}

MediumEvaluationWidget::MediumEvaluationWidget(QWidget* parent, Qt::WindowFlags flags)
	: MWidget(parent, flags)
{
	setupUi();
	setMedium(0);
}

void MediumEvaluationWidget::setMedium(Medium* medium)
{
	if(this->medium)
		medium->disconnect(this);
	this->medium = medium;
	
// 	if(medium)
// 		connect(medium, SIGNAL(changed()), this, SLOT(setEvaluationFromMedium()));
	
	bool enable = true;
	if(!medium)
		enable = false;
	setEnabled(enable);
	setEvaluationFromMedium();
}

void MediumEvaluationWidget::setEvaluation()
{
	if(!medium)
		return;
	
	medium->setEvaluation(evalEdit->currentText().toInt());
}

void MediumEvaluationWidget::setEvaluationFromMedium()
{
	if(medium)
		evalEdit->setCurrentIndex(evalEdit->findText(QString::number(medium->evaluation())));
}

void MediumEvaluationWidget::setupUi()
{
	this->medium = 0;
	QHBoxLayout *mainLayout = new QHBoxLayout(this);
	setLayout(mainLayout);
	mainLayout->setMargin(0);
	
	QLabel *label = new QLabel(tr("Evaluation:"), this);
	mainLayout->addWidget(label);
	label->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
	label->setMinimumSize(150, 23);
	
	evalEdit = new QComboBox(this);
	mainLayout->addWidget(evalEdit);
	evalEdit->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
	evalEdit->setMinimumSize(150, 23);
	evalEdit->setMaximumHeight(30);
	QStringList items;
	items << "0" << "1" << "2" << "3" << "4" << "5";
	evalEdit->addItems(items);
	connect(evalEdit, SIGNAL(currentIndexChanged(int)), this, SLOT(setEvaluation()));
}

#include "mediumevaluationwidget.moc"
