/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMKEYWORDWIDGET_H
#define MEDIUMKEYWORDWIDGET_H

#include "libmacro.h"
#include "mediumeditwidget.h"
#include "ui_mediumkeywordwidget.h"

class QSqlQueryModel;
class QStringListModel;

/**
	* Used to add, remove and view keywords related to a medium
	*/
class EXPORT_DLL MediumKeywordWidget : public MediumEditWidget, private Ui::MediumKeywordWidget
{
	Q_OBJECT
	public:
    MediumKeywordWidget(QWidget* parent = 0, Qt::WindowFlags flags = 0);
		
		bool store(bool useExistingTransaction = false);
		void setMedium(Medium* newMedium);

	private slots:
		void addKeyword();
		void removeKeyword();
		void selectedKeyword(QModelIndex index);
		
	private:
		/**
			* sets the model if keywordList to the medium one
			*/
		void renewModel();
		
		QSqlQueryModel *completerModel;
		QModelIndex index;
};

#endif // MEDIUMKEYWORDWIDGET_H
