/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMPERSONSWIDGET_H
#define MEDIUMPERSONSWIDGET_H

#include "libmacro.h"

#include <mwidget.h>

class Medium;
class ETableView;

#include <QModelIndex>
class MPushButton;

class EXPORT_DLL MediumPersonsWidget : public MWidget
{
	Q_OBJECT
	public:
		MediumPersonsWidget(Medium *medium, QWidget *parent = 0, Qt::WindowFlags flags = 0);
		MediumPersonsWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setDefaultRole(unsigned int roleId);
		void setMedium(Medium *medium);
		
	private slots:
		void loadFromMedium();
		void addPerson();
		void removePerson();
		void newRole();
		void clicked(QModelIndex index);
	
	private:
		void setupUi();
		
		Medium *medium;
		ETableView *personsView;
		MPushButton *removeButton;
		unsigned int defaultRole;
		QModelIndex index;
};

#endif // MEDIUMPERSONSWIDGET_H
