/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MIMETYPEMODEL_H
#define MIMETYPEMODEL_H

#include "libmacro.h"

#include <QAbstractItemModel>

class MimeModelItem;
class MimeType;

/**
  * model to represant MimeTypes, the application which can be used to open it, the suffix of the mimetype
  * and the default application choosen by the user
  */

class EXPORT_DLL MimeTypeModel : public QAbstractItemModel
{
    Q_OBJECT
  public:
    MimeTypeModel ( QObject *parent = 0 );
    ~MimeTypeModel();

    void addMimeType ( MimeType *mimeType );
    MimeType *getMimeType ( QString mimeType );
    MimeType *getMimeType ( int row );

    QModelIndex index ( int row, int column, const QModelIndex &parent = QModelIndex() ) const;
    QModelIndex parent ( const QModelIndex &index ) const;
    int rowCount ( const QModelIndex &parent = QModelIndex() ) const;
    int columnCount ( const QModelIndex &parent = QModelIndex() ) const;
    QVariant data ( const QModelIndex &index, int role = Qt::DisplayRole ) const;
    bool hasChildren ( const QModelIndex &parent = QModelIndex() ) const;
    QVariant headerData ( int section, Qt::Orientation orientation, int role = Qt::DisplayRole ) const;

    bool loadModel();

  signals:

  public slots:

  private:
    QList<MimeType*> mimeTypes;

    MimeModelItem* elementFromIndex ( const QModelIndex &index ) const;
};

#endif // MIMETYPEMODEL_H
