/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MODULELISTWIDGETITEM_H
#define MODULELISTWIDGETITEM_H

#include "libmacro.h"

#include <QListWidgetItem>
#include <QFileInfo>

class EXPORT_DLL ModuleListWidgetItem : public QListWidgetItem
{
  public:
    ModuleListWidgetItem ( QListWidget *parent = 0, int type = Type );
    ModuleListWidgetItem ( QString text, QListWidget * parent = 0, int type = Type );
    ModuleListWidgetItem ( QIcon icon, QString text, QListWidget *parent = 0, int type = Type );
    ModuleListWidgetItem ( QListWidgetItem other );

    void setName ( QString name );
    QString name() const;
    void setFile ( QString file );
    QString file() const;
    void setStatus ( bool status );
    bool status() const;
    void setErrorMessage ( QString message );
    QString errorMessage() const;
    void setDescription ( QString description );
    QString description() const;
		void setModuleIcon(QIcon modIcon);
		QIcon moduleIcon() const;
		
		bool operator== (const ModuleListWidgetItem &item) const;
    bool operator!= (const ModuleListWidgetItem &item) const;

  private:
    QFileInfo myFile;
    QString myErrorMessage;
    QString myDescription;
		QIcon myModuleIcon;
    bool myStatus;

    void init();
};

#endif // MODULELISTWIDGETITEM_H
