/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MSQLDATABASE_H
#define MSQLDATABASE_H

#include "config.h"
#include "libmacro.h"

#include <QSqlDatabase>

namespace KWallet {
	class Wallet;
}

class EXPORT_DLL MSqlDatabase : public QSqlDatabase
{
	public:
		MSqlDatabase ();
		MSqlDatabase ( const QSqlDatabase & other );
		MSqlDatabase ( const QString &useType );
    ~MSqlDatabase();

		bool loadAndCheckSettings(QString username, QString host, QString dbName,
																		QString newType, QString passwd);
		void setType(QString name);
		QString type();
		
// 		bool open();
		QStringList tables ( QSql::TableType type = QSql::Tables ) const;
		
// 		static MSqlDatabase addDatabase(const QString &useType, const QString &connectionName = QString());
		static bool checkSettings();
		/**
			* should be used thorughout the whole project,
			* because the orignal database function opens the connection automatically,
			* therefore bool closeDB = !db.isOpen() isn't working and transactions through
			* more than one database() does not work too!
			*/
		static MSqlDatabase database(QString connectionName = QLatin1String( defaultConnection ));
		
	private:
		/**
			* @return List of table names inside selected database (@see databaseName )
			*/
		QStringList tableList() const;
		/**
			* right now only default implementation will be called
			* @todo must be implemented
			*/
		QStringList systemTableList() const;
		/**
			* @return List of view names inside selected database (@see databaseName )
			*/
		QStringList viewList() const;
		/**
			* @return a combined list of all three other lists
			*/
		QStringList allList() const;
		
		void init();
		
		QString myType;
#ifdef KDE
		KWallet::Wallet *wallet;
#endif
};

#endif // MSQLDATABASE_H
