/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "program.h"

#include "mimetype.h"

#include <QString>
#include <QDir>
#include <QFileInfo>

Program::Program(QString newFilePath, MimeType *newParent) : MimeModelItem() {
  setParent(newParent);
  setProgram(QFileInfo(newFilePath));
}

MimeType *Program::parent() const
{
  return myParent;
}

void Program::setParent(MimeType *newParent)
{
  myParent = newParent;
}

void Program::setPath(QDir newPath)
{
  myFile.setFile(newPath, file().baseName());
}

void Program::setPath(QString newPath)
{
  setPath(QDir(newPath));
}

QDir Program::path() const
{
	QDir result(myFile.absoluteDir());
	if(myFile.isDir())
		result = QDir(myFile.absoluteFilePath());
  return result;
}

void Program::setProgram(QString newFile)
{
  myFile.setFile(path(), newFile);
}

void Program::setProgram(QFileInfo newFile)
{
  myFile = newFile;
}

QString Program::program() const
{
	return file().baseName();
}

QFileInfo Program::file() const
{
  return myFile;
}

void Program::setFilePath(QString newPath)
{
  myFile = QFileInfo(newPath);
}

bool Program::operator== (const Program &other) const
{
  if(program() == other.program()){
    return true;
	}
  return false;
}

bool Program::operator!= (const Program &other) const
{
	return !operator==(other);
}

