/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef Program_H
#define Program_H

#include "libmacro.h"

#include "mimemodelitem.h"

class MimeType;

#include <QDir>
#include <QString>
#include <QFileInfo>

class EXPORT_DLL Program : public MimeModelItem{
  public:
    Program(QString newFilePath = QString(), MimeType *newParent = 0);

    MimeType *parent() const;
    void setParent(MimeType *newParent = 0);
    void setPath(QDir newPath);
    void setPath(QString newPath);
		/**
			* path to program
			* (e.g. /usr/bin is the path of /usr/bin/kate)
			* can be set via @see setPath(QDir newPath) and @see setPath(QString newPath)
			*/
    QDir path() const;
		/**
			* the filename of the program
			* (e.g. kate from /usr/bin/kate)
			*/
    void setProgram(QString newFile);
		/**
			* set's path and filename at once
			* (e.g. @p newFile = "/usr/bin/kate" for kate)
			*/
    void setProgram(QFileInfo newFile);
		QString program() const;
		/**
			* all informations about the program filename
			*/
    QFileInfo file() const;
		/**
			* set's path and filename at once
			* (e.g. @p newFilePath = "/usr/bin/kate" for kate)
			*/
    void setFilePath(QString newFilePath) __attribute__ ((deprecated));

    bool operator== (const Program &other) const;
		bool operator!= (const Program &other) const;

  private:
    QFileInfo myFile;
    MimeType *myParent;
};

#endif // Program_H
