/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "config.h"

#include "progressstatuswidget.h"

ProgressStatusWidget::ProgressStatusWidget(QWidget* parent, Qt::WindowFlags flags)
	: MWidget(parent, flags)
{
	setObjectName("ProgressStatusWidget");
	myWasCanceled = false;
	setupUi(this);
	connect(cancelButton, SIGNAL(clicked()), this, SLOT(cancel()));
#if QT_VERSION_MINOR < 6
	cancelButton->setIcon(QIcon(":/icons/button_cancel.png"));
#else
	cancelButton->setIcon(QIcon::fromTheme("process-stop",
																					 QIcon(":/icons/button_cancel.png")));
#endif
}

bool ProgressStatusWidget::wasCanceled()
{
	return myWasCanceled;
}

void ProgressStatusWidget::setRange(int min, int max)
{
	progressBar->setRange(min, max);
}

void ProgressStatusWidget::setValue(int value)
{
	progressBar->setValue(value);
}

int ProgressStatusWidget::value()
{
	return progressBar->value();
}

void ProgressStatusWidget::setFormat(QString format)
{
	progressBar->setFormat(format);
}

void ProgressStatusWidget::setLabel(QString text)
{
	label->setText(text);
}

void ProgressStatusWidget::removeMe()
{
	close();
	emit removeStatusWidget(this);
}

void ProgressStatusWidget::cancel()
{
	emit canceled();
	myWasCanceled = true;
}

#include "progressstatuswidget.moc"
