/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "scaledimage.h"

#include <QPainter>
#include <QSize>

ScaledImage::ScaledImage(QPixmap image, QWidget* parent, Qt::WindowFlags flags)
	: QLabel(parent, flags)
{
	setPixmap(image);
}

ScaledImage::ScaledImage(QWidget* parent, Qt::WindowFlags flags)
	: QLabel(parent, flags)
{
}

void ScaledImage::setImage(QPixmap image)
{
	// this line is really important, because otherwise
	// sizeHint is equal to pixmap size and only enlargment of
	// the label is possible
	setSizePolicy(QSizePolicy::Ignored, QSizePolicy::Ignored);
	// center the pixmap into the QLabel
	setAlignment(Qt::AlignCenter);
	myImage = image;
	if(!myImage.isNull())
		QLabel::setPixmap(myImage.scaled(size(), Qt::KeepAspectRatio));
}

QPixmap ScaledImage::image()
{
	return myImage;
}

void ScaledImage::resizeEvent(QResizeEvent* event)
{	
	QLabel::resizeEvent(event);
	
	if(myImage.isNull())
		return;
	
	setPixmap(myImage.scaled(size(), Qt::KeepAspectRatio));
}

#include "scaledimage.moc"
