/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef SETTINGSSTANDARDWIDGET_H
#define SETTINGSSTANDARDWIDGET_H

#include "libmacro.h"

#include "mwidget.h"

#include <QString>
#include <QSettings>

/**
  * The base class of the all widgets used to display settings at the settings dialog
  */

class EXPORT_DLL SettingsWidget : public MWidget
{
    Q_OBJECT;

  public:
    SettingsWidget ( QWidget *parent = 0, Qt::WindowFlags flags = 0 );
    ~SettingsWidget();

    /**
      * used to display the name of the tab into a section
      */
    QString name();

  public slots:
    /**
      * this function should save all presented settings
      */
    virtual bool saveSettings() = 0;

  protected:
    void setName ( QString newName );
    QString myName;

  signals:
    void setError ( QString msg );
};
#endif
