/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef SETUPWIZARDDB_H
#define SETUPWIZARDDB_H

#include "libmacro.h"

#include "setupwizardobject.h"

class SqlInit;

#include <QPointer>

class EXPORT_DLL SetupWizardDB : public SetupWizardObject
{
  Q_OBJECT
  public:
		/**
			* @note This object takes control over the given @p dbInit, therefore it is automatically deleted!
			*/
    SetupWizardDB ( QString newTitle, SqlInit *dbInit, QObject *parent = 0 );

    bool needed();
    bool finish ( SetupWizardWidget *finishWidget );
    QList<SetupWizardWidget*> wizardWidgets();

  private:
    bool needDBSettings, needDBUpdate;
    QPointer<SqlInit> sqlInit;
};

#endif // SETUPWIZARDDB_H
