/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef SQLLOGIN_H
#define SQLLOGIN_H

#include "libmacro.h"
#include "config.h"

#include "mdialog.h"

#include <QWidget>

namespace KWallet {
	class Wallet;
}

namespace Ui
{
  class SqlLogin;
}

class EXPORT_DLL SqlLogin : public MDialog
{
  Q_OBJECT
  public:
    SqlLogin ( QWidget *parent = 0 );
    SqlLogin ( QString title, QString newConnName, QWidget *parent = 0 );
    ~SqlLogin();
    QStringList data();
    void reloadSettingsByPass();
    bool loadAndCheckSettings(QString username = QString(),
															QString host = QString(),
															QString database = QString(),
															QString driver = QString(),
															QString password = QString());
    static bool checkSettings();

  public slots:
    int exec();

  protected:
    void changeEvent ( QEvent *e );

  private slots:
    void finish();
    void showSettingsDialog();
		void usernameChanged();

  private:
		void init();

    void displayError ( QString msg );
    void displayInformation ( QString msg );
		
    Ui::SqlLogin *m_ui;
    QString host;
    QString driver;
    QString database;
    QString connName;
		QString username, password;
    bool withoutDatabase, useSSL;
#ifdef KDE
		KWallet::Wallet *wallet;
#endif
};

#endif // SQLLOGIN_H
