/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef BOOKEDIT_H
#define BOOKEDIT_H

#include "editmedium.h"

#include <QModelIndex>

class Book;

class QSqlQueryModel;
class QLineEdit;
class QSpinBox;
class QDateEdit;

/**
	* This widget is used to edit the data of a book.
	* It apperas in the cases, add a new book and edit a given book
	*/

class BookEdit : public EditMedium
{
  Q_OBJECT
  public:
    BookEdit ( QWidget* parent = 0, Qt::WindowFlags flags = 0 );

	protected:
		void loadData(Medium *medium);
		bool prepareSave(Medium *medium);

  private:
		QLineEdit *pubPlaceEdit;
		QSpinBox *editionEdit, *pagesEdit;
		QDateEdit *pubDateEdit;
};

#endif // BOOKEDIT_H
