/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "books.h"

#include "setupwizardobject.h"
#include "setupwizarddb.h"
#include "booksdb.h"
#include "booksmodel.h"
#include "booksearchwidget.h"
#include "book.h"
#include "searchdetailswidget.h"

#include <QtPlugin>
#include <QStringList>
#include <QIcon>

Books::Books ( QObject *parent ) : MediaPlugin()
{

}

Books::~Books()
{

}

bool Books::initiate ()
{
  return true;
}

bool Books::unload ()
{
  return true;
}

QString Books::name ()
{
  return tr ( "Books" );
}

QString Books::group()
{
  return "books";
}

QIcon Books::icon ()
{
  return QIcon();
}

QString Books::description ()
{
  return tr ( "Plugin is able to handle media of type book" );
}

MediaModel *Books::newModel ( QString materialType, QueryThread *thread )
{
	if(materialType != tr ( "Book" ))
		return 0;
  BooksModel *model = new BooksModel ( thread, this );
  return model;
}

SearchDetailsWidget *Books::searchWidget ( QString materialType )
{
	if(materialType != tr ( "Book" ))
		return 0;
  return new BookSearchWidget();
}

bool Books::store ()
{
  return false;
}

bool Books::load ()
{
  return false;
}

QStringList Books::supportedAttributes (QString materialType)
{
  Book book;
  return book.supportedAttributes();
}

SettingsWidget *Books::settingsWidget ()
{
  return 0;
}

SetupWizardObject *Books::wizardObject()
{
  return new SetupWizardDB ( tr ( "Configure Database of Books" ), new BooksDB ( ), this );
}

QStringList Books::supportedMaterialTypes()
{
  QStringList result;
  result << tr ( "Book" );
  return result;
}

void Books::show ()
{

}

void Books::settingsChanged ()
{

}

void Books::print ()
{

}

void Books::save ()
{

}

void Books::doExport ()
{

}

void Books::redo ()
{

}

void Books::undo ()
{

}

void Books::cut ()
{

}

void Books::copy ()
{

}

void Books::paste ()
{

}

void Books::reload ()
{

}

void Books::reloadSettingsByPass ()
{

}

#include "books.moc"

Q_EXPORT_PLUGIN2 ( Meganizer_Books, Books )
