/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "booksdb.h"

#include "books.h"

BooksDB::BooksDB ( QObject *parent ) : SqlInit ( parent )
{
  init();
}

void BooksDB::scheme()
{
  currentVersion = 5;
  thisName = Books::group();
  moduleLabel = "Books";

  SqlTable *table = addTable ( thisName + "_books" );

  SqlField *field = table->appendField ( "materialsId", SqlField::integer, true );
  field->isUnsigned ( true );
  table->addForeignKey ( field->name(), "materials", "id" );

  field = table->appendField ( "pages", SqlField::integer );
  field->isUnsigned ( true );

  field = table->appendField ( "edition", SqlField::integer );
  field->isUnsigned ( true );

  field = table->appendField ( "publicationPlace", SqlField::varchar );
  field->length ( 120 );

  field = table->appendField ( "publicationDate", SqlField::date );

  table = addTable ( "materialtypes" );
  table->appendField ( "name", SqlField::varchar );
  table->appendField ( "description", SqlField::varchar );

  QStringList insert;
  insert << "" << tr ( "Book" ) << tr ( "All medias which are books" );
  table->appendValues ( insert );
  
  table = addTable("materialpersonsroles");
  table->appendField("name", SqlField::varchar);
  table->appendField("description", SqlField::varchar);
  
  insert.clear();
  insert << "" << tr("Author") << tr("The author of the material");
  table->appendValues(insert);
  insert.clear();
  insert << "" << tr("Editor") << tr("The editor of a book (abbr.: Ed., ed.)");
  table->appendValues(insert);
	
	QStringList view;
  view.append ( thisName +"_viewbooks" );
  view.append ( "SELECT  mats.*, books.pages, books.edition, books.publicationPlace, books.publicationDate"
                "  FROM viewmaterials mats "
                "  LEFT JOIN "+ thisName +"_books books ON mats.id=books.materialsId");
  views.append ( view );
}

#include "booksdb.moc"
