/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "moviesdb.h"
#include "moviesdb.moc"

#include "movies.h"

#include <QSqlQuery>
#include <QSqlRecord>
#include <QSqlError>

MoviesDB::MoviesDB ( QObject *parent ) : SqlInit ( parent )
{
  init();
}

void MoviesDB::scheme()
{
  currentVersion = 1;
  thisName = Movies::group();
  moduleLabel = Movies::myName();

	SqlTable *devices = addTable ( thisName +"_devices" );
	SqlField *field = devices->appendField( "name", SqlField::varchar, true );
	field->length(50);
	devices->addIndex(field, 10);
	field = devices->appendField ( "description", SqlField::varchar );
	field->length(500);
	
	QStringList values;
	values << "" << tr("DVD") << tr("Digital Versatile Disc");
	devices->appendValues(values);
	values.clear();
	values << "" << tr("File") << tr("File on HDD");
	devices->appendValues(values);
	values.clear();
	
  SqlTable *table = addTable ( thisName + "_movies" );
  field = table->appendField ( "materialsId", SqlField::integer, true );
  field->isUnsigned ( true );
  table->addForeignKey ( field->name(), "materials", "id" );

  field = table->appendField ( "publicationDate", SqlField::date );
	table->addForeignKey ( devices );

  table = addTable ( "materialtypes" );
  table->appendField ( "name", SqlField::varchar );
  table->appendField ( "description", SqlField::varchar );

	QStringList insert;
  insert << "" << tr ( "Movie" ) << tr ( "Movies" );
	table->appendValues ( insert );
	insert.clear();

  table = addTable("materialpersonsroles");
  table->appendField("name", SqlField::varchar);
  table->appendField("description", SqlField::varchar);
  
  insert.clear();
	insert << "" << tr("Actor") << tr("The artist who perfoms in the movie");
  table->appendValues(insert);
	insert.clear();
	insert << "" << tr("Director") << tr("The director of the movie");
  table->appendValues(insert);

	QStringList view;
	view.append ( thisName +"_viewmovies" );
  view.append ( "SELECT  mats.*, movies.publicationDate, movies.devicesId"
                "  FROM viewmaterials mats "
                "  LEFT JOIN "+ thisName +"_movies movies ON mats.id=movies.materialsId");
  views.append ( view );
}
