/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef CD_H
#define CD_H

#include "medium.h"

#include <QDate>

class TracksModel;

/**
  * Represants a CD with Tracks
	* @todo add tracks
	*/
class CD : public Medium
{
	Q_OBJECT
  public:
    CD ( Medium *parent = 0 );
    ~CD();

		Medium *newMedium();
    bool select( QSqlRecord record);
    bool select ( unsigned int searchId, unsigned int userId = 0 );
    bool store(bool addOwner = false, bool startTransaction = true);
		/**
			* @attention to set Tracks in albumMode, the following structure is needed:
			* @attention QStringList cd, track, title, length (may be empty, format: hh:mm:ss)
			*/
    bool setValue ( QString attribute, QVariant value );
    QVariant value ( QString attribute, int role );
    EditMedium *editWidget(MWidget* parent = 0);

    void setDiscs ( unsigned int numDisks );
    unsigned int discs() const;
		void setDevice ( unsigned int deviceId, bool setName = true );
		void setDevice ( QString name, bool setId = true );
		unsigned int device() const;
		QString deviceName() const;

    void setPublicationDate ( QDate newDate );
    QDate publicationDate() const;
		
		Medium* copyMedium();
		bool exportMedium(QTextTable* table, Medium::ExportFormat format, bool titleOnly = false);
		
		// handle tracks
    TracksModel *tracks() const;
    bool removeTrack(QModelIndex index);

		QList<ColKeyTrans> supportedAttrs();
		
  private:
		bool loadTracks();
		
    unsigned int myDiscs, myDeviceId;
		QString myDeviceName;
    QDate myPublicationDate;
		TracksModel *myTracks;
};

#endif // CD_H
