/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "tracksmodeltest.h"
#include "tracksmodeltest.moc"

#include "tracksmodel.h"
#include "track.h"
#include <modeltest.h>

#include <QtTest/QtTest>

void TracksModelTest::testModel()
{
	baseTests(new TracksModel(0, this));
}

void TracksModelTest::switchModes()
{
	TracksModel *model = new TracksModel(0, this);
	ModelTest *modeltest = new ModelTest(model, 0, this);
	
	Track *track = new Track();
	track->setTitle("Test Track");
	QCOMPARE(model->addMedium(track), true);
	
	model->setAlbumMode(false);
	model->setCollectionMode(false);
	QCOMPARE(model->albumMode(), false);
	QCOMPARE(model->collectionMode(), false);
	QCOMPARE(model->columnCount(), 5);
	QCOMPARE(model->headerData(0, Qt::Horizontal).toString(), QString("Source"));
	QCOMPARE(track->albumMode(), false);
	QCOMPARE(track->collectionMode(), false);
	
	// switching to album mode
	model->setAlbumMode(true);
	QCOMPARE(model->albumMode(), true);
	QCOMPARE(model->collectionMode(), false);
	QCOMPARE(model->columnCount(), 5);
	QCOMPARE(model->headerData(0, Qt::Horizontal).toString(), QString("Disc"));
	QCOMPARE(track->albumMode(), true);
	QCOMPARE(track->collectionMode(), false);
	
	// switching to collection mode
	model->setCollectionMode(true);
	QCOMPARE(model->albumMode(), false);
	QCOMPARE(model->collectionMode(), true);
	QCOMPARE(model->columnCount(), 4);
	QCOMPARE(model->headerData(0, Qt::Horizontal).toString(), QString("Nr"));
	QCOMPARE(track->albumMode(), false);
	QCOMPARE(track->collectionMode(), true);
}

QTEST_MAIN(TracksModelTest)
