/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H

#include <mdialog.h>
#include "ui_settingsdialog.h"

#include <settingswidget.h>
class MediaPlugin;
class SearchPlugin;

#include <QMultiHash>

class SettingsDialog : public MDialog, private Ui::SettingsDialog {
  Q_OBJECT

  public:
    SettingsDialog(QList<MediaPlugin*> mediaPlugins, QList<SearchPlugin*> searchPlugins, QWidget* parent = 0, Qt::WindowFlags fl = 0 );
    ~SettingsDialog();
          
  
  public slots:
          
  
  protected:
		void closeEvent(QCloseEvent *event);

  private slots:
    bool saveSettings();
    void saveQuit();
    void cancel();
    void setError(QString msg);

    void changeContent(int row);

  private:
    QList<SettingsWidget*> widgets;
    QMultiHash<int, QString> mapStackWidget;
    QList<MediaPlugin*> mediaPlugins;
		QList<SearchPlugin*> searchPlugins;

    /**
      * adds the content widgets to the stackLayout and adds the entries to the sectionList
      **/
    void addContent();
    void addPlugins();
};

#endif

