/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "setupuser.h"

#include "setupuserwidget.h"
#include <msqldatabase.h>

#include <QSqlQuery>
#include <QSqlRecord>

SetupUser::SetupUser ( QObject* parent ) : SetupWizardObject ( parent )
{
  setTitle ( tr ( "Create your user" ) );
}

SetupUser::~SetupUser()
{

}

QList< SetupWizardWidget* > SetupUser::wizardWidgets()
{
  QList<SetupWizardWidget*> result;
  result.append ( new SetupUserWidget ( this ) );
  return result;
}

bool SetupUser::finish ( SetupWizardWidget* finishWidget )
{
  SetupUserWidget *widget = qobject_cast<SetupUserWidget* > ( finishWidget );
  if ( !widget )
    return false;
  return widget->finish();
}

bool SetupUser::needed()
{
  MSqlDatabase db = MSqlDatabase::database();
	bool closeDB = !db.isOpen();
  if ( !db.open() )
    return true;

  QSqlQuery query ( QString ( "SELECT id, name, givenName, userName, email FROM users WHERE userName='%1'" ).arg ( db.userName() ) );
  if ( !query.exec() ) {
		if(closeDB)
			db.close();
    return true;
  }

  if ( !query.first() ) {
    if(closeDB)
			db.close();
    return true;
  }

  if ( ( query.record().value ( "name" ).toString().isEmpty() ) || ( query.record().value ( "givenName" ).toString().isEmpty() ) ) {
    if(closeDB)
			db.close();
    return true;
  }

  if(closeDB)
			db.close();
  return false;
}

#include "setupuser.moc"
